<?php
/**
****************************
Begin Fake Pages 
****************************
**/



/** Register Custom Post Type */
add_action('init', 'books_register');
 
function books_register() {
 
	$labels = array(
		'name' => _x('Books', 'post type general name'),
		'singular_name' => _x('Book', 'post type singular name'),
		'add_new' => _x('Add New', 'book'),
		'add_new_item' => __('Add New Book'),
		'edit_item' => __('Edit Book'),
		'new_item' => __('New Book'),
		'view_item' => __('View Book'),
		'search_items' => __('Search Books'),
		'not_found' =>  __('No books found'),
		'not_found_in_trash' => __('No books found in Trash'),
		'parent_item_colon' => ''
	);
 
	$args = array(
		'labels' => $labels,
		'public' => true,
		'publicly_queryable' => true,
		'show_ui' => true,
		'query_var' => true,
		'menu_icon' => get_stylesheet_directory_uri() . '/images/book16x16.png',
		'rewrite' => true,
		'has_archive' => true,
		'capability_type' => 'post',
		'hierarchical' => true,
		'menu_position' => null,
		'supports' => array('title','editor','thumbnail',
                    'custom-fields', 'comments')
	  ); 


	register_post_type( 'books' , $args );
}	


/** Functions.php Addition/Plugin Content  */

// Fake pages' permalinks and titles
    $my_fake_pages = array(
        'reviews' => 'Reviews',
        'purchase' => 'Purchase',
        'author' => 'Author Bio'
    );
     
    add_filter('rewrite_rules_array', 'fsp_insertrules');
    add_filter('query_vars', 'fsp_insertqv');
     
    // Adding fake pages' rewrite rules
    function fsp_insertrules($rules)
    {
        global $my_fake_pages;
     
		$newrules = array();
		foreach ($my_fake_pages as $slug => $title)
			$newrules['books/([^/]+)/' . $slug . '/?$'] = 'index.php?books=$matches[1]&fpage=' . $slug;
     
        return $newrules + $rules;
    }
     
    // Tell WordPress to accept our custom query variable
    function fsp_insertqv($vars)
    {
        array_push($vars, 'fpage');
        return $vars;
    }

    // Remove WordPress's default canonical handling function
	
    remove_filter('wp_head', 'rel_canonical');
    add_filter('wp_head', 'fsp_rel_canonical');
    function fsp_rel_canonical()
    {
        global $current_fp, $wp_the_query;
     
        if (!is_singular())
            return;
     
        if (!$id = $wp_the_query->get_queried_object_id())
            return;
     
        $link = trailingslashit(get_permalink($id));
     
        // Make sure fake pages' permalinks are canonical
        if (!empty($current_fp))
            $link .= user_trailingslashit($current_fp);
     
        echo '<link rel="canonical" href="'.$link.'" />';
    }

/* Yoast Canonical Removal from Book pages */
add_filter( 'wpseo_canonical', 'wpseo_canonical_exclude' );

function wpseo_canonical_exclude( $canonical ) {
		global $post;
		if (is_singular('books')) {
    		$canonical = false;
    }
	return $canonical;
}